Subject: [Mip4] length value of extensions related to dsmipv4

From: Jun AWANO <[email-masked]>
Date: Wed, 21 Mar 2007 17:15:30 +0100

Hi,

I'm implementing DSMIPv4 based on current draft.
But I'm confused because length value of IPv6 Prefix Extension, IPv6
Code Extension and IPv6 Tunneling Mode Extension are including Type and
Length fields.
Those extensions are Short Extension Format defined in RFC3344.
So, I think it should be value excluding Type and Length fields.
Is it right?

Best Regards,
Jun

-- 
Mip4 mailing list: [email-masked]
    Web interface: https://www1.ietf.org/mailman/listinfo/mip4
     Charter page: http://www.ietf.org/html.charters/mip4-charter.html
Supplemental site: http://www.mip4.org/

---

From: "Tsirtsis, George" <[email-masked]>
Date: Thu, 22 Mar 2007 05:18:24 -0700

Hi Jun,

I am happy to see you are implementing the draft and I would encourage
you to share with us any problems you might come up with.

With respect to your question, yes, the extensions are following the
short format which is defined in RFC3344, Section 1.11, from which I
quote:

"1.11.  Short Extension Format

   This format is compatible with the skippable extensions defined in
   section 1.9.  It is not applicable for extensions which require more
   than 256 bytes of data; for such extensions, use the format described
   in section 1.10.

     0                   1                   2                   3
     0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |     Type      |   Length      |    Sub-Type   |    Data ....
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ "

This is the format I used in the DSMIPv4 draft. For example the IPv6
Prefix Extension is defined as:

       0                   1                   2                   3
       0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |      Type     |   Length      |   Sub-Type    | Prefix Length |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |                                                               |
      +                                                               +
      |                                                               |
      +                   Mobile IPv6 Network Prefix                  +
      |                                                               |
      +                                                               +
      |                                                               |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

The Type, Length and Sub-Type values are that of the short extension
format and the Data field includes Prefix Length and Mobile IPv6 Network
Prefix fields.

Is this OK?

George

> -----Original Message-----
> From: Jun AWANO [mailto:[email-masked]]
> Sent: Wednesday, March 21, 2007 5:16 PM
> To: Mobile IPv4 Mailing List
> Subject: [Mip4] length value of extensions related to dsmipv4
> 
> Hi,
>

---

From: "McCann Peter-A001034" <[email-masked]>
Date: Thu, 22 Mar 2007 08:24:41 -0400

Hi,

I think Jun's question was prompted by the specification of
the Length field as "20".  Jun is saying it should be "18", because
it shouldn't include the Type and Length fields.

-Pete

Tsirtsis, George wrote:
> Hi Jun,
> 
> I am happy to see you are implementing the draft and I would
> encourage you to share with us any problems you might come up with. 
> 
>    section 1.9.  It is not applicable for extensions which require
>    more than 256 bytes of data; for such extensions, use the format
>    described in section 1.10.
> 
>      0                   1                   2                   3
> " 
> +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ |  
> Type     |   Length      |   Sub-Type    | Prefix Length |
> +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ |  
> | +                                                               + |
> | +                   Mobile IPv6 Network Prefix                  + |
> | +                                                               + |
> | +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  
> 
> format and the Data field includes Prefix Length and Mobile IPv6
> Network Prefix fields.  
> 
> Is this OK?
> 
> George
> 
>> Code Extension and IPv6 Tunneling Mode Extension are including Type
>> and Length fields. Those extensions are Short Extension Format
>> defined in RFC3344. 
>>      Charter page:
>> http://www.ietf.org/html.charters/mip4-charter.html Supplemental
>> site: http://www.mip4.org/

---

From: "Tsirtsis, George" <[email-masked]>
Date: Thu, 22 Mar 2007 05:30:25 -0700

Ah yes, I misunderstood the question. Jun is very correct. The Length
values of the three extensions should be as follows:

IPv6 Prefix Extension: 		 Length = 18
IPv6 Code Extension: 		 Length = 20
IPv6 Tunneling Mode Extension: Length = 2

I will fix this in the next version.

Thanks
George
> From: McCann Peter-A001034 [mailto:[email-masked]]
> Sent: Thursday, March 22, 2007 1:25 PM
> To: Tsirtsis, George; Jun AWANO; Mobile IPv4 Mailing List
> Subject: RE: [Mip4] length value of extensions related to dsmipv4
> 
> Hi,
> 
> > | +                                                               +
|
> > | +                                                               +
|

---

From: Jun AWANO <[email-masked]>
Date: Thu, 22 Mar 2007 14:28:45 +0100

Hi, George and Pete

Thank you for your early reply.
My intention was exactly what Pete said.

George> I will fix this in the next version.
Thanks, George.

-Jun

-- 
-----------------------------------------------
Jun AWANO <[email-masked]>
NEC Ubiquitous Platform Development Division
Tel:+81 3 5476 9798, FAX:+81 3 5476 1005